> ## Documentation Index
> Fetch the complete documentation index at: https://documentation.byteful.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Search Services

> Search Services on the customer account using various filters.




## OpenAPI

````yaml get /public/user/service/search
openapi: 3.0.1
info:
  title: Byteful Public User API
  description: Public API used for third-party usage.
  termsOfService: https://byteful.com
  contact:
    url: https://byteful.com
    email: developer@byteful.com
  version: '1.0'
  x-logo:
    altText: Byteful
    backgroundColor: '#6354eb'
    url: >-
      https://pbs.twimg.com/profile_banners/1038803520605118464/1729783007/1500x500
servers:
  - url: https://api.byteful.com/1.0/
security: []
paths:
  /public/user/service/search:
    get:
      tags:
        - Service
      summary: Search Services
      description: |
        Search Services on the customer account using various filters.
      parameters:
        - name: service_id
          in: query
          description: ID of the service
          schema:
            type: string
        - name: service_status
          in: query
          description: Current status of the service
          schema:
            type: string
            enum:
              - awaiting_fulfillment
              - awaiting_manual_fulfillment
              - awaiting_additional_fulfillment
              - active
              - canceled
              - complete
              - overdue
              - paused
        - name: service_name
          in: query
          description: Name of the service
          schema:
            type: string
        - name: service_type
          in: query
          description: Type of the service
          schema:
            type: string
            enum:
              - datacenter
              - isp
              - residential
              - mobile
        - name: service_protocol
          in: query
          description: Protocol of the service
          schema:
            type: string
            enum:
              - ipv4
              - ipv6
              - dual
        - name: service_quantity
          in: query
          description: Quantity of the service
          schema:
            type: integer
        - name: payment_method_id
          in: query
          description: Payment method ID of the service
          schema:
            type: integer
        - name: service_total
          in: query
          description: Total amount of the service
          schema:
            type: string
        - name: service_cycle
          in: query
          description: Service cycle (e.g., "1:month")
          schema:
            type: string
        - name: service_dispatch_datetime
          in: query
          description: Datetime the service was dispatched
          schema:
            type: string
            format: date-time
        - name: service_expiry_datetime
          in: query
          description: Datetime the service will expire
          schema:
            type: string
            format: date-time
        - name: service_image
          in: query
          description: URL of the service image
          schema:
            type: string
        - name: service_is_automatic_collection
          in: query
          description: If the service is set for automatic collection
          schema:
            type: boolean
        - name: service_is_pending_cancellation
          in: query
          description: If the service is pending cancellation
          schema:
            type: boolean
        - name: country_id
          in: query
          description: >-
            ISO Country Code [(ISO 3166-1
            alpha-2)](https://www.iban.com/country-codes)
          schema:
            type: string
        - name: service_price_id
          in: query
          description: Price ID of the service
          schema:
            type: integer
        - name: product_id
          in: query
          description: Product ID of the service
          schema:
            type: integer
        - name: service_promotional_code
          in: query
          description: Promotional code of the service
          schema:
            type: string
        - name: service_subscription_id
          in: query
          description: Subscription ID of the service
          schema:
            type: integer
        - name: service_creation_datetime
          in: query
          description: Datetime the service was created
          schema:
            type: string
            format: date-time
        - name: service_last_update_datetime
          in: query
          description: Datetime the service was last updated
          schema:
            type: string
            format: date-time
        - name: proxies
          in: query
          description: If the proxies associated with the service should be returned
          schema:
            type: boolean
        - name: per_page
          in: query
          description: Number of items per page for pagination
          schema:
            type: integer
        - name: page
          in: query
          description: Page number for pagination
          schema:
            type: integer
        - name: sort_by
          in: query
          description: Key for sorting or random.
          schema:
            type: string
      responses:
        '200':
          description: Successful Service search
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/ServiceSuccessfulSearchResponse'
                  - type: object
                    properties:
                      data:
                        type: array
                        items:
                          type: object
                          properties:
                            proxies:
                              type: array
                              items:
                                $ref: '#/components/schemas/Proxy'
      security:
        - APIPrivateKey: []
          APIPublicKey: []
components:
  schemas:
    ServiceSuccessfulSearchResponse:
      type: object
      properties:
        data:
          type: array
          description: >-
            Array of Service items matching the search criteria up to the limit
            of per_page paramater.
          items:
            type: object
            properties:
              country_id:
                type: string
                example: us
              open_invoice_id:
                type: string
                example: inv_1OCNVFFKo7UQ3XWITWlqGWYQ
              payment_method_id:
                type: string
                example: pm_1NjyqfB2BUlqim5l2LgRUo0a
              service_creation_datetime:
                type: string
                format: date-time
              service_cycle:
                type: string
                example: 1:month
              service_dispatch_datetime:
                type: string
                format: date-time
              service_earliest_cancellation_datetime:
                type: string
                format: date-time
              service_expiry_datetime:
                type: string
                format: date-time
              service_id:
                type: string
                example: API-1234-5678
              service_image:
                type: string
                example: https://apple.com/image.png
              service_is_automatic_collection:
                type: boolean
                example: true
              service_is_pending_cancellation:
                type: boolean
                example: false
              service_last_update_datetime:
                type: string
                format: date-time
              service_metadata:
                type: object
                properties: {}
                example:
                  resell_customer_id: APPL-9876-5432
              service_name:
                type: string
                example: Premium ISP
              service_promotional_code:
                type: string
                example: PROMO2023
              service_protocol:
                type: string
                example: ipv4
                enum:
                  - ipv4
                  - ipv6
                  - dual
              service_quantity:
                type: integer
                example: 5
              service_status:
                type: string
                example: active
                enum:
                  - awaiting_manual_fulfillment
                  - awaiting_additional_fulfillment
                  - awaiting_fulfillment
                  - active
                  - canceled
                  - complete
                  - paused
                  - overdue
              service_subscription_id:
                type: string
                example: sub_1NpPVfB2BUlqim5lA374YoIh
              service_subscription_is_paused:
                type: boolean
                example: false
              service_total:
                type: integer
                example: 100
              service_type:
                type: string
                example: isp
                enum:
                  - datacenter
                  - isp
                  - residential
                  - mobile
                  - off_catalog
              subscription_schedule_id:
                type: string
                example: sub_sched_1OCNVFFKo7UQ3XWITWlqGWYQ
        item_count:
          type: integer
          description: Total number of Service items returned in the data field.
        message:
          type: string
          description: Status message for the search.
        page:
          type: integer
          description: Current page number of the search results returned.
        per_page:
          type: integer
          description: Number of Service items returned per page.
        total_count:
          type: integer
          description: Total of Service items that match the search filter.
      description: Service search was successful.
      example:
        data:
          - country_id: us
            open_invoice_id: inv_1OCNVFFKo7UQ3XWITWlqGWYQ
            payment_method_id: pm_1NjyqfB2BUlqim5l2LgRUo0a
            service_creation_datetime: '2023-09-12 10:00:00'
            service_cycle: 1:month
            service_dispatch_datetime: '2023-09-12 11:00:00'
            service_earliest_cancellation_datetime: '2023-09-12 12:00:00'
            service_expiry_datetime: '2023-10-12 10:00:00'
            service_id: API-1234-5678
            service_image: https://apple.com/image.png
            service_is_automatic_collection: true
            service_is_pending_cancellation: false
            service_last_update_datetime: '2023-09-12 12:00:00'
            service_metadata:
              resell_customer_id: APPL-9876-5432
            service_name: Premium ISP
            service_promotional_code: PROMO2023
            service_protocol: ipv4
            service_quantity: 5
            service_status: active
            service_subscription_id: sub_1NpPVfB2BUlqim5lA374YoIh
            service_subscription_is_paused: false
            service_total: 100
            service_type: isp
            subscription_schedule_id: sub_sched_1OCNVFFKo7UQ3XWITWlqGWYQ
        item_count: 1
        message: Service search successful.
        page: 1
        per_page: 10
        total_count: 1
    Proxy:
      type: object
      properties:
        asn_id:
          type: integer
          example: 7018
        asn_name:
          type: string
          example: AT&T Enterprises, LLC
        city_example_postcode:
          type: string
          example: '75202'
        city_id:
          type: integer
          example: 75202
        city_latitude:
          type: number
          example: 32.7767
        city_longitude:
          type: number
          example: -96.797
        city_name:
          type: string
          example: Dallas
        city_timezone:
          type: string
          example: America/Chicago
        country_id:
          type: string
          example: us
        country_name:
          type: string
          example: United States
        customer_id:
          type: integer
          example: 1955
        default_proxy_user_password:
          type: string
          example: apple1984
        default_proxy_user_username:
          type: string
          example: stevejobs
        ip_address_id_v4:
          type: string
          example: 107.225.73.142
        ip_address_id_v6:
          type: string
          example: 2600:1000:b12a:6351:8523:997e:93c4:f124
        proxy_http_port:
          type: integer
          example: 8080
        proxy_id:
          type: string
          example: 7a018d34-76c2-4c23-b14d-f7b9a7054e25
        proxy_ip_address:
          type: string
          example: 107.225.73.142
        proxy_ip_address_v6:
          type: string
          example: 2600:1000:b12a:6351:8523:997e:93c4:f124
        proxy_last_update_datetime:
          type: string
          format: date-time
        proxy_password:
          type: string
          example: DHf3PSQXQ7rw1v9
        proxy_protocol:
          type: string
          example: ipv4
          enum:
            - ipv4
            - ipv6
            - dual
        proxy_socks5_port:
          type: integer
          example: 1080
        proxy_status:
          type: string
          example: in_use
          enum:
            - available
            - in_use
            - reserved
            - waiting
            - pending_deletion
        proxy_type:
          type: string
          example: isp
          enum:
            - datacenter
            - isp
            - residential
            - mobile
        proxy_user_ids:
          type: array
          items:
            type: string
            example: stevejobs
        proxy_username:
          type: string
          example: att7018user
        service_id:
          type: string
          example: API-1234-5678
        subdivision_id:
          type: string
          example: us-tx
        subdivision_name:
          type: string
          example: Texas
        subnet_id:
          type: string
          example: 107.225.72.0/22
        subnet_id_v6:
          type: string
          example: 2600:1000::/28
  securitySchemes:
    APIPrivateKey:
      type: apiKey
      description: ' Private API key for user-level authentication.'
      name: X-API-Private-Key
      in: header
    APIPublicKey:
      type: apiKey
      description: ' Public API key for user-level authentication.'
      name: X-API-Public-Key
      in: header

````